var triggerID = "trigger-" + uuidv4();
var menuID = "menu-" + uuidv4();
var dropdownID = "dropdown-" + uuidv4();
var dropdownScript =
  '<script data-runtime-script="true" type="disabled">' +
  "$(document).ready(function() {\n" +
  '   !function(e,t,n,i){e.fn.dropdownMenu=function(t){var n=e.extend({trigger:"click",transition:"fade",speed:250},t);return this.each(function(){function t(){"fade"===n.transition?d.stop(!1,!0).fadeToggle(n.speed).toggleClass("open-menu"):"slide"===n.transition?d.stop(!1,!0).slideToggle(n.speed).toggleClass("open-menu"):"none"===n.transition&&d.toggle().toggleClass("open-menu"),d.hasClass("open-menu")?i.height(a+d.height()).width(s):i.height(o.height()).width(o.width())}var i=e(this),o=i.find(\'[id*="trigger"]\'),d=i.find(\'[id*="menu"]\'),a=parseInt(d.css("top"),10),s=i.width();d.hide().attr("data-hidden",!1).attr("data-alt-hidden",!1).css("visibility","visible"),i.width(o.width()).height(o.height()),"click"===n.trigger?(o.on("click",function(e){e.preventDefault(),e.stopPropagation(),t()}),e("body").on("click",function(){d.hasClass("open-menu")&&t()})):"hover"===n.trigger&&(i.hover(function(){t()}),o.on("click",function(e){e.preventDefault()})),e(".pagecloud-widget--fixed-header").css("max-height","0px")})}}(jQuery,window,document);\n\n' +
  "   var element = $('#" +
  dropdownID +
  "');\n" +
  "   element.dropdownMenu({\n" +
  "      trigger: 'hover', /* click, hover */\n" +
  "      transition: 'fade', /* fade, slide, none */\n" +
  "      speed: 250 /* speed of transition */\n" +
  "    });\n" +
  "});\n" +
  "</script>";

var trigger = $("a.selected");
var menu = $(".selected").not("a");

trigger.attr("id", triggerID);
menu.attr("id", menuID);
menu.css("visibility", "hidden");

var group = PageCloud.Groups.groupObjects($(".selected"), { undo: false });
group.attr("id", dropdownID).append(dropdownScript);

PageCloud.Depth.moveObjectsToBack(trigger);
PageCloud.Selection.selectOnly(group);

function uuidv4() {
  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(c) {
    var r = (Math.random() * 16) | 0,
      v = c == "x" ? r : (r & 0x3) | 0x8;
    return v.toString(16);
  });
}
